
	

	counter equ 0x021

	org 0x000
	goto start

	org 0x030
start
	bcf     STATUS,RP1
	bsf 	STATUS,RP0		;bank 1
	movlw 	B'11110000'		;0-3 outputs, 4-7 inputs for push buttons
	movwf 	TRISB
	clrf	TRISD			;all output for 7-segments
	clrf	TRISE			;all 3bits output for enabling 7-segments
	bcf		OPTION_REG,7	;enable pull-ups of PORTB for push buttons (RBPU bit)

	bcf		STATUS,RP0		;bank 0
	clrf	PORTE
	
	movlw	10
	movwf	counter

	
loop
	movlw 	B'11111110'		;check buttons 00,01,02,03
	movwf 	PORTB		
		btfss	PORTB,4
		goto	button_00
		btfss	PORTB,5
		goto	button_01
		btfss	PORTB,6
		goto	button_02
		btfss	PORTB,7
		goto	button_03

	movlw 	B'11111101'		;check buttons 04,05,06,07
	movwf 	PORTB
		btfss	PORTB,4
		goto	button_04
		btfss	PORTB,5
		goto	button_05
		btfss	PORTB,6
		goto	button_06
		btfss	PORTB,7
		goto	button_07				
	
	movlw 	B'11111011'		;check buttons 08,09,10,11
	movwf 	PORTB
		btfss	PORTB,4
		goto	button_08
		btfss	PORTB,5
		goto	button_09
		btfss	PORTB,6
		goto	button_10
		btfss	PORTB,7
		goto	button_11

	movlw 	B'11110111'		;check buttons 12,13,14,15
	movwf 	PORTB
		btfss	PORTB,4
		goto	button_12
		btfss	PORTB,5
		goto	button_13
		btfss	PORTB,6
		goto	button_14
		btfss	PORTB,7
		goto	button_15

	goto loop
	

button_00
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'01111110'		;show 0
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'01111110'		;show 0
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_00
	goto	cont


button_01
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'01111110'		;show 0
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'00110000'		;show 1
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_01
	goto	cont


button_02
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'01111110'		;show 0
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'01101101'		;show 2
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_02
	goto	cont


button_03
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'01111110'		;show 0
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'01111001'		;show 3
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_03
	goto	cont


button_04
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'01111110'		;show 0
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'00110011'		;show 4
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_04
	goto	cont


button_05
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'01111110'		;show 0
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'01011011'		;show 5
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_05
	goto	cont


button_06
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'01111110'		;show 0
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'01011111'		;show 6
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_06
	goto	cont


button_07
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'01111110'		;show 0
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'01110000'		;show 7
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_07
	goto	cont


button_08
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'01111110'		;show 0
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'01111111'		;show 8
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_08
	goto	cont


button_09
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'01111110'		;show 0
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'01111011'		;show 9
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_09
	goto	cont


button_10
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'00110000'		;show 1
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'01111110'		;show 0
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_10
	goto	cont


button_11
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'00110000'		;show 1
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'00110000'		;show 1
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_11
	goto	cont


button_12
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'00110000'		;show 1
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'01101101'		;show 2
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_12
	goto	cont


button_13
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'00110000'		;show 1
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'01111001'		;show 3
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_13
	goto	cont


button_14
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'00110000'		;show 1
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'00110011'		;show 4
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_14
	goto	cont


button_15
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'00110000'		;show 1
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'01011011'		;show 5
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_15
	goto	cont


cont
	movlw	10
	movwf	counter

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'00000000'		;show blank
	movwf	PORTD

	goto	loop



	end
