package gui;

import javax.swing.*;

import java.awt.*;
import java.awt.event.*;


/** 
 * A JTabbedPane which has a close ('X') icon on each tab.
 *
 * To add a tab, use the method addTab(String, Component)
 *
 * To have an extra icon on each tab (e.g. like in JBuilder, showing the file type) use
 * the method addTab(String, Component, Icon). Only clicking the 'X' closes the tab.
 */
@SuppressWarnings("serial")
public class JTabbedPaneWithCloseIcons extends JTabbedPane implements MouseListener{
 
	public GuiController guiController;
	public JFrame callerFrame;
	
	public JTabbedPaneWithCloseIcons(int tabPlacement, int tabLayoutPolicy) {
		super(tabPlacement, tabLayoutPolicy);
		// TODO Auto-generated constructor stub
	}

	public JTabbedPaneWithCloseIcons(int tabPlacement) {
		super(tabPlacement);
		// TODO Auto-generated constructor stub
	}

  public JTabbedPaneWithCloseIcons(GuiController gController, JFrame cFrame) {
    super();
    guiController = gController;
    callerFrame = cFrame;
    this.addMouseListener(this);
  }
  
  public JTabbedPaneWithCloseIcons() {
	    super();
	    this.addMouseListener(this);
	  }
 
  @Override
public void addTab(String title, Component component) {
    this.addTab(title, component, null);
  }
 
  public void addTab(String title, Component component, Icon extraIcon) {
    super.addTab(title, new CloseTabIcon(extraIcon), component);
  }
 
  public void mouseClicked(MouseEvent e) {
    int tabNumber=this.getUI().tabForCoordinate(this, e.getX(), e.getY());
    System.out.println("tabNumber = " + tabNumber);
    
    if (tabNumber < 0) 
    	return;
    CloseTabIcon temp = (CloseTabIcon) this.getIconAt(tabNumber);
    
    
    temp.getBounds();
    
    Rectangle rect=temp.getBounds();
    
    if (rect.contains(e.getX(), e.getY())) {
      //the tab is being closed
      this.removeTabAt(tabNumber);
    }
  }
 
  public void mouseEntered(MouseEvent e) {}
  public void mouseExited(MouseEvent e) {}
  public void mousePressed(MouseEvent e) {}
  public void mouseReleased(MouseEvent e) {}
}