/**
 * 
 */
package gui;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Date;

import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;

/**
 * This class holds the main function, which initializes and
 * runs the program.
 * @author maho
 *
 */

public class Main {

	public static final String SYSTEM_FILE_PATH = "pide.sys";//probably will change after exact place of pide.sys is defined
	
	public static void main(String[] args) {
		// TODO Auto-generated method stub
	
	
		 try {
			UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
			
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (InstantiationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (UnsupportedLookAndFeelException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		File systemFile = new File(SYSTEM_FILE_PATH);
		
		//check if the file is already created. If not create one
		//Here we should find the difference between first creation and
		//loss of system file.
		if( ! systemFile.exists())
		{
			System.out.println("Creating default system file");
			createDefaultSystemFile();
		}
		
		boolean success = (new File("Projects")).mkdir();
	    if (success) {
	      System.out.println("Creating default project directory");
	    }   
		
		PFrame frame = new PFrame();
		frame.setVisible(true);
		frame.setDefaultCloseOperation(2);
	}
	/**
	 * Creates a default system file. Used when the program is first created
	 * or when the program cannot find a valid system file.
	 *
	 */
	private static void  createDefaultSystemFile()
	{
		File systemFile  = new File(SYSTEM_FILE_PATH);
		
		
		FileWriter systemFileWriter = null;
		try {
			systemFileWriter = new FileWriter(systemFile);
			//System.out.println(systemFile.canWrite());
		
		} catch (IOException e) {
			// TODO Auto-generated catch block
			System.out.println("System file could not be created! Exiting program.");
			e.printStackTrace();
		}
		try {
			//initial comments
			systemFileWriter.write("#PIDE vers. 1.0"); 
			systemFileWriter.write('\n');
			systemFileWriter.write("#Install date: " + new Date().toString());
			systemFileWriter.write('\n');
			systemFileWriter.write("#You are discouraged to change the values in this file since");
			systemFileWriter.write('\n');
			systemFileWriter.write("#it may cause unexpected program behavior. For an emergency case,");
			systemFileWriter.write('\n');
			systemFileWriter.write("#please refer to system manual.");
			systemFileWriter.write('\n');
			
			//latest workspaces
			systemFileWriter.write("#Active Workspace");
			systemFileWriter.write('\n');
			systemFileWriter.write("#Latest Workspaces");
			systemFileWriter.write('\n');
						
			//Latest System Settings 			
			systemFileWriter.write("#Latest System Settings");
			systemFileWriter.write('\n');
			systemFileWriter.write("#set on " + new Date().toString());
			systemFileWriter.write('\n');
		
			//Recent files
			systemFileWriter.write("#Recent files");
			systemFileWriter.write('\n');
			systemFileWriter.write("recent_documents:");
			systemFileWriter.write('\n');
			systemFileWriter.write("recent_projects:");
			systemFileWriter.write('\n');
	
			//Editor Settings
			systemFileWriter.write("#Editor Settings");
			systemFileWriter.write('\n');
			
			systemFileWriter.close();
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		

	}

}
