package gui;

import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.File;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.border.EtchedBorder;
import javax.swing.tree.DefaultMutableTreeNode;

import projectManager.PIDEFile;
import projectManager.ProjectFile;

/**
 * This class creates a new project dialog. After dialog is disposed,
 * a project workspace is created and workspace panel is updated.
 */
@SuppressWarnings("serial")
public class NewProjectFrame extends JFrame {

	
	public PFrame mainFrame = null;
	public WorkspacePane workspacePane = null;
	
	private JPanel mainPanel = null;
	private JLabel projectNameLabel = null;
	private JTextField projectNameTextField = null;
	private JRadioButton radioButton1 = null;
	private JRadioButton radioButton2 = null;
	private JLabel directoryNameLabel = null;
	private JTextField directoryNameTextField = null;
	private JButton browseButton = null;
	private ButtonGroup createProjectButtonGroup = null;  //  @jve:decl-index=0:
	private JPanel panel2 = null;
	private JPanel bottomPanel = null;
	private JPanel centerPanel = null;
	private JPanel bottomRightPanel = null;
	private JButton finishButton = null;
	private JButton cancelButton = null;
	private JLabel jLabel = null;
	private JScrollPane jScrollPane = null;
	private JTextArea projectDescriptionTextField = null;
	
	public NewProjectFrame(PFrame pFrame, WorkspacePane workspacePane) {
		super();
		this.mainFrame = pFrame;
		this.workspacePane = workspacePane;
		this.mainFrame.setEnabled(false);
		initialize();
	}

	/**
	 * This method initializes the new file dialog attributes
	 * 
	 */
	private void initialize() {
        this.setSize(new Dimension(559, 349));
        this.setContentPane(getMainPanel());
        this.setTitle("New Project");
        this.setResizable(false);
        this.setFocusable(true);
        this.setAlwaysOnTop(true);
        
        this.addWindowListener(new WindowListener(){

			public void windowActivated(WindowEvent e) {
				// TODO Auto-generated method stub
				
			}

			public void windowClosed(WindowEvent e) {
				// TODO Auto-generated method stub
				
			}

			public void windowClosing(WindowEvent e) {
				// TODO Auto-generated method stub
				dispose();
				mainFrame.setEnabled(true);
			}

			public void windowDeactivated(WindowEvent e) {
				// TODO Auto-generated method stub
				
			}

			public void windowDeiconified(WindowEvent e) {
				// TODO Auto-generated method stub
				
			}

			public void windowIconified(WindowEvent e) {
				// TODO Auto-generated method stub
				
			}

			public void windowOpened(WindowEvent e) {
				// TODO Auto-generated method stub
				
			}});
        getCreateProjectButtonGroup();
			
	}

	/**
	 * This method initializes mainPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getMainPanel() {
		if (mainPanel == null) {
			directoryNameLabel = new JLabel();
			directoryNameLabel.setText("Directory:    ");
			projectNameLabel = new JLabel();
			projectNameLabel.setBounds(new Rectangle(13, 16, 112, 20));
			projectNameLabel.setText("Project Name:");
			mainPanel = new JPanel();
			mainPanel.setLayout(null);
			mainPanel.add(projectNameLabel, null);
			mainPanel.add(getProjectNameTextField(), null);
			mainPanel.add(getCenterPanel(), null);
			mainPanel.add(getBottomRightPanel(), null);
		}
		return mainPanel;
	}

	/**
	 * This method initializes projectNameTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getProjectNameTextField() {
		if (projectNameTextField == null) {
			projectNameTextField = new JTextField();
			projectNameTextField.setBounds(new Rectangle(143, 16, 382, 19));
			projectNameTextField.addKeyListener(new KeyListener(){

				public void keyPressed(KeyEvent e) {
					// TODO Auto-generated method stub
					
				
				}

				public void keyReleased(KeyEvent e) {
					// TODO Auto-generated method stub
					
					if(projectNameTextField.getText().length() > 0)
						getFinishButton().setEnabled(true);
					else getFinishButton().setEnabled(false);
					
				}

				public void keyTyped(KeyEvent e) {
					// TODO Auto-generated method stub
					
				}});
		}
		return projectNameTextField;
	}

	/**
	 * This method initializes radioButton1	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getRadioButton1() {
		if (radioButton1 == null) {
			radioButton1 = new JRadioButton("Create Project in Workspace", true);
			radioButton1.setText("Create project in workspace");
			radioButton1.addItemListener(new ItemListener(){

				public void itemStateChanged(ItemEvent e) {
					// TODO Auto-generated method stub
					//getBottomPanel().setEnabled(false);
					directoryNameLabel.setEnabled(false);
					getDirectoryNameTextField().setEnabled(false);
					getBrowseButton().setEnabled(false);
				}});
		}
		return radioButton1;
	}

	/**
	 * This method initializes radioButton2	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getRadioButton2() {
		if (radioButton2 == null) {
			radioButton2 = new JRadioButton("Create project in a different folder", false);
			radioButton2.setText("Create project in a different folder");
			radioButton2.addItemListener(new ItemListener(){

				public void itemStateChanged(ItemEvent e) {
					directoryNameLabel.setEnabled(true);
					getDirectoryNameTextField().setEnabled(true);
					getBrowseButton().setEnabled(true);
				}});
		}
		return radioButton2;
	}

	/**
	 * This method initializes directoryNameTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getDirectoryNameTextField() {
		if (directoryNameTextField == null) {
			directoryNameTextField = new JTextField();
		}
		return directoryNameTextField;
	}

	/**
	 * This method initializes browseButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBrowseButton() {
		if (browseButton == null) {
			browseButton = new JButton();
			browseButton.setText("Browse");
			browseButton.addActionListener(new ActionListener(){

				public void actionPerformed(ActionEvent e) {
					// TODO Auto-generated method stub
					
					JFileChooser fileChooser = new JFileChooser(getDirectoryNameTextField().getText());
					
					fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
					searchNDestroy(fileChooser);
					
					int returnVal = fileChooser.showDialog(null, "OK");
				        if(returnVal == JFileChooser.APPROVE_OPTION) {
				            File selected = fileChooser.getSelectedFile();
				            getDirectoryNameTextField().setText(selected.getAbsolutePath());
				        }
				}});
		}
		return browseButton;
	}
	/**
	 * 
	 * Searches the components of a container object and get rids of unwanted elements
	 */
	public static void searchNDestroy(Container cont){
		 
        if(!(cont instanceof Container)) {
            return;
        }
 
        int n = cont.getComponentCount();

 
        for(int i=0; i<n; i++) {
            JComponent comp;
            try{
                comp = (JComponent)cont.getComponent(i);
            }catch(Exception e){
                continue;
            }
            if(comp instanceof JButton) {
            	JButton lbl= (JButton)comp;
                if (lbl.getText().startsWith("Rename")||lbl.getText().startsWith("Delete")){ // look for the button with text "Files of Type"
                    comp.setVisible(false);
                    continue;
                }
            }
           
             if(comp instanceof Container){
             
                try{
                    searchNDestroy((Container)comp);
                }catch(Exception e){
                }
            }
        }    
} 

	public ButtonGroup getCreateProjectButtonGroup() {
		if (createProjectButtonGroup == null) {
			createProjectButtonGroup = new ButtonGroup();
			createProjectButtonGroup.add(getRadioButton1());
			createProjectButtonGroup.add(getRadioButton2());
		}
		return createProjectButtonGroup;
	}

	/**
	 * This method initializes panel2	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPanel2() {
		if (panel2 == null) {
			panel2 = new JPanel();
			panel2.setLayout(new BoxLayout(getPanel2(), BoxLayout.Y_AXIS));
			panel2.setBounds(new Rectangle(11, 138, 492, 54));
			panel2.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.RAISED));
			panel2.add(getRadioButton1(), null);
			panel2.add(getRadioButton2(), null);
		}
		return panel2;
	}

	/**
	 * This method initializes bottomPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getBottomPanel() {
		if (bottomPanel == null) {
			bottomPanel = new JPanel();
			bottomPanel.setLayout(new BoxLayout(getBottomPanel(), BoxLayout.X_AXIS));
			bottomPanel.setBounds(new Rectangle(11, 199, 493, 26));
			bottomPanel.add(directoryNameLabel, null);
			bottomPanel.add(getDirectoryNameTextField(), null);
			bottomPanel.add(getBrowseButton(), null);
			directoryNameLabel.setEnabled(false);
			getDirectoryNameTextField().setEnabled(false);
			getBrowseButton().setEnabled(false);
		}
		return bottomPanel;
	}

	/**
	 * This method initializes centerPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getCenterPanel() {
		if (centerPanel == null) {
			jLabel = new JLabel();
			jLabel.setBounds(new Rectangle(10, 5, 126, 24));
			jLabel.setFont(new Font("Dialog", Font.BOLD, 12));
			jLabel.setText("Project Description :");
			centerPanel = new JPanel();
			centerPanel.setLayout(null);
			centerPanel.setBounds(new Rectangle(9, 45, 519, 232));
			centerPanel.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
			centerPanel.add(getPanel2(), null);
			centerPanel.add(getBottomPanel(), null);
			centerPanel.add(jLabel, null);
			centerPanel.add(getJScrollPane(), null);
		}
		return centerPanel;
	}

	/**
	 * This method initializes bottomRightPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getBottomRightPanel() {
		if (bottomRightPanel == null) {
			bottomRightPanel = new JPanel();
			bottomRightPanel.setLayout(new BoxLayout(getBottomRightPanel(), BoxLayout.X_AXIS));
			bottomRightPanel.setBounds(new Rectangle(368, 279, 159, 33));
			bottomRightPanel.add(getFinishButton(), null);
			bottomRightPanel.add(getCancelButton(), null);
		}
		return bottomRightPanel;
	}

	/**
	 * This method initializes finishButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getFinishButton() {
		if (finishButton == null) {
			finishButton = new JButton();
			finishButton.setText("Finish");
			finishButton.setEnabled(false);
			finishButton.addActionListener(new ActionListener(){

				public void actionPerformed(ActionEvent e) {
					File workspaceDirectory = null;
					ProjectFile projectFile = null;
					String directoryPath = null;
					if(mainFrame.systemFile.existsActiveProject)//move existing active project into non-active projects list
					{
						mainFrame.systemFile.activeWorkspaces.add(mainFrame.activeProject.getProjectPath().substring(0, mainFrame.activeProject.getProjectPath().length()-1));
						
					}
					else mainFrame.systemFile.existsActiveProject = true;
					
					if(radioButton2.isSelected())
					{
						directoryPath = directoryNameTextField.getText();
						if(directoryPath.lastIndexOf(File.separatorChar) == directoryPath.length()-1)//last char is a seperator. get rid of it
						{
							directoryPath = directoryPath+projectNameTextField.getText();
						}
						else 
						{
							directoryPath = directoryPath + File.separator + projectNameTextField.getText();
						}
						workspaceDirectory = new File(directoryPath);
						workspaceDirectory.mkdir();
					
						projectFile = new ProjectFile(PIDEFile.PROJECT,projectNameTextField.getText(),
											directoryPath, projectDescriptionTextField.getText() );
						
						mainFrame.activeProject = projectFile.project;
						mainFrame.activeProjectFile = projectFile;
					}
					else
					{
						directoryPath = "."+File.separator+"Projects"+File.separator+projectNameTextField.getText();
						workspaceDirectory = new File(directoryPath);
						workspaceDirectory.mkdir();
						projectFile = new ProjectFile(PIDEFile.PROJECT,projectNameTextField.getText(),
								directoryPath, projectDescriptionTextField.getText());//!!description eklenmeli,workspace yaratlmal
						mainFrame.activeProject = projectFile.project;
						mainFrame.activeProjectFile = projectFile;
						//System.out.println("ACTIVEPROJECT: "+mainFrame.activeProject);
					}
					
					mainFrame.workspacePane.activeProjectFile = mainFrame.activeProjectFile;
					//add new project to system file
					
					mainFrame.systemFile.activeProject = directoryPath;
					mainFrame.systemFile.save();
					//add new project to workspace tree
					
					workspacePane.projectRoot.removeAllChildren();
					String inactiveProjectPath = null;
					int start = 0;
					int end =0;
					
					DefaultMutableTreeNode activeworkspaceNode = new DefaultMutableTreeNode(mainFrame.activeProject.getProjectName());
					
					for (int i = 0; i < mainFrame.activeProjectFile.fileList.size(); i++) {
						inactiveProjectPath = mainFrame.activeProjectFile.fileList.get(i);
						
						start = inactiveProjectPath.lastIndexOf(File.separatorChar)+1;
						end = inactiveProjectPath.length();
						inactiveProjectPath = inactiveProjectPath.substring(start,end);
						
						activeworkspaceNode.add(new DefaultMutableTreeNode(inactiveProjectPath));
					}
					
					workspacePane.projectRoot.add(activeworkspaceNode);
					
					
					for(int i = 0; i < mainFrame.systemFile.activeWorkspaces.size();i++)
					{
						inactiveProjectPath = (String)mainFrame.systemFile.activeWorkspaces.get(i);
						
						start = inactiveProjectPath.lastIndexOf(File.separatorChar)+1;
						end = inactiveProjectPath.length();
						inactiveProjectPath = inactiveProjectPath.substring(start,end);
						
						workspacePane.projectRoot.add(new DefaultMutableTreeNode(inactiveProjectPath));
						
					}
					
					workspacePane.model.nodeStructureChanged((DefaultMutableTreeNode) workspacePane.model.getRoot());
					dispose();
					mainFrame.setEnabled(true);
					mainFrame.setVisible(true);
					
				}});
		}

		return finishButton;
	}

	/**
	 * This method initializes cancelButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getCancelButton() {
		if (cancelButton == null) {
			cancelButton = new JButton();
			cancelButton.setText("Cancel");
			cancelButton.addActionListener(new ActionListener(){

				public void actionPerformed(ActionEvent e) {
					// TODO Auto-generated method stub
					dispose();
					mainFrame.setEnabled(true);
					mainFrame.setVisible(true);
				}});
		}
		return cancelButton;
	}

	/**
	 * This method initializes jScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setBounds(new Rectangle(12, 32, 489, 101));
			jScrollPane.setViewportView(getJTextArea());
		}
		return jScrollPane;
	}

	/**
	 * This method initializes jTextArea	
	 * 	
	 * @return javax.swing.JTextArea	
	 */
	private JTextArea getJTextArea() {
		if (projectDescriptionTextField == null) {
			projectDescriptionTextField = new JTextArea();
		}
		return projectDescriptionTextField;
	}

}  //  @jve:decl-index=0:visual-constraint="29,7"
