package picmicrocontroller;

/**
 * This class represents the flash memory of a PIC16F877.
 * Flash memory consists of 8*1024 registers.
 * 
 */
public class FlashProgramMemory {
	private int data[];
	
	/**
	 * Main constructor that initializes the data memory. 
	 * All registers are filled with 3FFF (addlw 0).
	 */
	FlashProgramMemory()
	{
		this.data = new int[8*1024];
		for(int i=0; i<(8*1024); i++)
		{
			this.data[i]= Integer.parseInt("3FFF", 16);
			//System.out.println("writing 3FFF to address " + i);
		}
	}
	
	/**
	 * Writes the value into the given adress.
	 * @param address 
	 * @param word value to be written
	 */
	public void write(int address, int word) 
	{
		this.data[address] = word;
		//System.out.println("writing " + word + " to address " + address);
	}
	
	/**
	 * Reads the value from given adress.
	 */
	public int read(int address)
	{
		return this.data[address];		
	}

	
	
}
