/**
 * 
 */
package simulator;

import java.awt.Color;
import java.awt.Font;
import java.awt.Rectangle;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JPanel;

import peripherals.KeyPad;
import peripherals.PushButton;

/**
 * This class is the visualisation of the key pad peripheral of
 * CENG336 board
 * @author maho
 *
 */
@SuppressWarnings("serial")
public class KeyPadPanel extends JPanel {

	
	private KeyPad keyPad;
	/*Buttons on the interface that represent push-buttons on CEng336 Board*/
	private JButton jButton = null;
	private JButton jButton1 = null;
	private JButton jButton2 = null;
	private JButton jButton3 = null;
	private JButton jButton4 = null;
	private JButton jButton5 = null;
	private JButton jButton6 = null;
	private JButton jButton7 = null;
	private JButton jButton8 = null;
	private JButton jButton9 = null;
	private JButton jButton10 = null;
	private JButton jButton11 = null;
	private JButton jButton12 = null;
	private JButton jButton13 = null;
	private JButton jButton14 = null;
	private JButton jButton15 = null;
	
	
	
	
	
	/**
	 * Main constructor for the keypad panel. Sets the keypad simulator
	 * and initializes the panel.
	 * @param pad 
	 * 
	 */
	public KeyPadPanel(KeyPad keyPad) {
		super();
		this.keyPad = keyPad;
		initialize();

		
	}
		

	/**
	 * This method initializes the key pad panel
	 * 
	 */
	private void initialize() {
        this.setLayout(null);
        this.setBounds(new Rectangle(310, 245, 220, 222));
        this.setBorder(BorderFactory.createMatteBorder(5, 5, 5, 5, Color.black));
        this.add(getJButton(), null);
        this.add(getJButton1(), null);
        this.add(getJButton2(), null);
        this.add(getJButton3(), null);
        this.add(getJButton4(), null);
        this.add(getJButton5(), null);
        this.add(getJButton6(), null);
        this.add(getJButton7(), null);
        this.add(getJButton8(), null);
        this.add(getJButton9(), null);
        this.add(getJButton10(), null);
        this.add(getJButton11(), null);
        this.add(getJButton12(), null);
        this.add(getJButton13(), null);
        this.add(getJButton14(), null);
        this.add(getJButton15(), null);
    
	}

	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton() {
		if (this.jButton == null) {
			this.jButton = new JButton();
			this.jButton.setText("0");
			jButton.setBounds(new Rectangle(10, 10, 50, 50));
			this.jButton.setFont(new Font("Dialog", Font.BOLD, 12));
			this.jButton.addMouseListener(new MouseListener() {

				public void mouseClicked(MouseEvent e) {

				}

				public void mouseEntered(MouseEvent e) {
					

				}

				public void mouseExited(MouseEvent e) {
					

				}

				public void mousePressed(MouseEvent e) {
					
					KeyPadPanel.this.keyPad.setButtonState(0, PushButton.BUTTON_DOWN);
					System.out.println("button0 press");
				}

				public void mouseReleased(MouseEvent e) {
				
					KeyPadPanel.this.keyPad.setButtonState(0, PushButton.BUTTON_UP);
					System.out.println("button0 release");

				}});
		}
		return this.jButton;
	}

	/**
	 * This method initializes jButton1	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton1() {
		if (this.jButton1 == null) {
			this.jButton1 = new JButton();
			this.jButton1.setText("1");
			jButton1.setBounds(new Rectangle(60, 10, 50, 50));
			this.jButton1.setFont(new Font("Dialog", Font.BOLD, 12));
			this.jButton1.addMouseListener(new MouseListener() {

				public void mouseClicked(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mouseEntered(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mouseExited(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mousePressed(MouseEvent arg0) {
					// TODO Auto-generated method stub
					KeyPadPanel.this.keyPad.setButtonState(1, PushButton.BUTTON_DOWN);
					//System.out.println("button1 press");
				}

				public void mouseReleased(MouseEvent arg0) {
					// TODO Auto-generated method stub
					KeyPadPanel.this.keyPad.setButtonState(1, PushButton.BUTTON_UP);
					//System.out.println("button1 release");
				}});
		}
		return this.jButton1;
	}

	/**
	 * This method initializes jButton2	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton2() {
		if (this.jButton2 == null) {
			this.jButton2 = new JButton();
			this.jButton2.setText("2");
			jButton2.setBounds(new Rectangle(110, 10, 50, 50));
			this.jButton2.setFont(new Font("Dialog", Font.BOLD, 12));
			this.jButton2.addMouseListener(new MouseListener() {

				public void mouseClicked(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mouseEntered(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mouseExited(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mousePressed(MouseEvent arg0) {
					// TODO Auto-generated method stub
					KeyPadPanel.this.keyPad.setButtonState(2, PushButton.BUTTON_DOWN);
					//System.out.println("button2 press");
				}

				public void mouseReleased(MouseEvent arg0) {
					// TODO Auto-generated method stub
					KeyPadPanel.this.keyPad.setButtonState(2, PushButton.BUTTON_UP);
					//System.out.println("button2 release");
				}});
		}
		return this.jButton2;
	}

	/**
	 * This method initializes jButton3	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton3() {
		if (this.jButton3 == null) {
			this.jButton3 = new JButton();
			this.jButton3.setText("3");
			jButton3.setBounds(new Rectangle(160, 10, 50, 50));
			this.jButton3.setFont(new Font("Dialog", Font.BOLD, 12));
			this.jButton3.addMouseListener(new MouseListener() {

				public void mouseClicked(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mouseEntered(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mouseExited(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mousePressed(MouseEvent arg0) {
					// TODO Auto-generated method stub
					KeyPadPanel.this.keyPad.setButtonState(3, PushButton.BUTTON_DOWN);
					//System.out.println("button3 press");
				}

				public void mouseReleased(MouseEvent arg0) {
					// TODO Auto-generated method stub
					KeyPadPanel.this.keyPad.setButtonState(3, PushButton.BUTTON_UP);
					//System.out.println("button3 release");
				}});
		}
		return this.jButton3;
	}

	/**
	 * This method initializes jButton4	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton4() {
		if (this.jButton4 == null) {
			this.jButton4 = new JButton();
			this.jButton4.setText("4");
			jButton4.setBounds(new Rectangle(10, 60, 50, 50));
			this.jButton4.setFont(new Font("Dialog", Font.BOLD, 12));
			this.jButton4.addMouseListener(new MouseListener() {

				public void mouseClicked(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mouseEntered(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mouseExited(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mousePressed(MouseEvent arg0) {
					// TODO Auto-generated method stub
					KeyPadPanel.this.keyPad.setButtonState(4, PushButton.BUTTON_DOWN);
					//System.out.println("button4 press");
				}

				public void mouseReleased(MouseEvent arg0) {
					// TODO Auto-generated method stub
					KeyPadPanel.this.keyPad.setButtonState(4, PushButton.BUTTON_UP);
					//System.out.println("button4 release");
				}});
		}
		return this.jButton4;
	}

	/**
	 * This method initializes jButton5	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton5() {
		if (this.jButton5 == null) {
			this.jButton5 = new JButton();
			this.jButton5.setText("5");
			jButton5.setBounds(new Rectangle(60, 60, 50, 50));
			this.jButton5.setFont(new Font("Dialog", Font.BOLD, 12));
			this.jButton5.addMouseListener(new MouseListener() {

				public void mouseClicked(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mouseEntered(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mouseExited(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mousePressed(MouseEvent arg0) {
					// TODO Auto-generated method stub
					KeyPadPanel.this.keyPad.setButtonState(5, PushButton.BUTTON_DOWN);
					//System.out.println("button5 press");
				}

				public void mouseReleased(MouseEvent arg0) {
					// TODO Auto-generated method stub
					KeyPadPanel.this.keyPad.setButtonState(5, PushButton.BUTTON_UP);
					//System.out.println("button5 release");
				}});
		}
		return this.jButton5;
	}

	/**
	 * This method initializes jButton6	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton6() {
		if (this.jButton6 == null) {
			this.jButton6 = new JButton();
			this.jButton6.setText("6");
			jButton6.setBounds(new Rectangle(110, 60, 50, 50));
			this.jButton6.setFont(new Font("Dialog", Font.BOLD, 12));
			this.jButton6.addMouseListener(new MouseListener() {

				public void mouseClicked(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mouseEntered(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mouseExited(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mousePressed(MouseEvent arg0) {
					// TODO Auto-generated method stub
					KeyPadPanel.this.keyPad.setButtonState(6, PushButton.BUTTON_DOWN);
					//System.out.println("button6 press");
				}

				public void mouseReleased(MouseEvent arg0) {
					// TODO Auto-generated method stub
					KeyPadPanel.this.keyPad.setButtonState(6, PushButton.BUTTON_UP);
					//System.out.println("button6 release");
				}});
		}
		return this.jButton6;
	}

	/**
	 * This method initializes jButton7	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton7() {
		if (this.jButton7 == null) {
			this.jButton7 = new JButton();
			this.jButton7.setText("7");
			jButton7.setBounds(new Rectangle(160, 60, 50, 50));
			this.jButton7.setFont(new Font("Dialog", Font.BOLD, 12));
			this.jButton7.addMouseListener(new MouseListener() {

				public void mouseClicked(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mouseEntered(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mouseExited(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mousePressed(MouseEvent arg0) {
					// TODO Auto-generated method stub
					KeyPadPanel.this.keyPad.setButtonState(7, PushButton.BUTTON_DOWN);
					//System.out.println("button7 press");
				}

				public void mouseReleased(MouseEvent arg0) {
					// TODO Auto-generated method stub
					KeyPadPanel.this.keyPad.setButtonState(7, PushButton.BUTTON_UP);
					//System.out.println("button7 release");
				}});
		}
		return this.jButton7;
	}

	/**
	 * This method initializes jButton8	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton8() {
		if (this.jButton8 == null) {
			this.jButton8 = new JButton();
			this.jButton8.setText("8");
			jButton8.setBounds(new Rectangle(10, 110, 50, 50));
			this.jButton8.setFont(new Font("Dialog", Font.BOLD, 12));
			this.jButton8.addMouseListener(new MouseListener() {

				public void mouseClicked(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mouseEntered(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mouseExited(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mousePressed(MouseEvent arg0) {
					// TODO Auto-generated method stub
					KeyPadPanel.this.keyPad.setButtonState(8, PushButton.BUTTON_DOWN);
					//System.out.println("button8 press");
				}

				public void mouseReleased(MouseEvent arg0) {
					// TODO Auto-generated method stub
					KeyPadPanel.this.keyPad.setButtonState(8, PushButton.BUTTON_UP);
					//System.out.println("button8 release");
				}});
		}
		return this.jButton8;
	}

	/**
	 * This method initializes jButton9	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton9() {
		if (this.jButton9 == null) {
			this.jButton9 = new JButton();
			this.jButton9.setText("9");
			jButton9.setBounds(new Rectangle(60, 110, 50, 50));
			this.jButton9.setFont(new Font("Dialog", Font.BOLD, 12));
			this.jButton9.addMouseListener(new MouseListener() {

				public void mouseClicked(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mouseEntered(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mouseExited(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mousePressed(MouseEvent arg0) {
					// TODO Auto-generated method stub
					KeyPadPanel.this.keyPad.setButtonState(9, PushButton.BUTTON_DOWN);
					//System.out.println("button9 press");
				}

				public void mouseReleased(MouseEvent arg0) {
					// TODO Auto-generated method stub
					KeyPadPanel.this.keyPad.setButtonState(9, PushButton.BUTTON_UP);
					//System.out.println("button9 release");
				}});
		}
		return this.jButton9;
	}

	/**
	 * This method initializes jButton10	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton10() {
		if (this.jButton10 == null) {
			this.jButton10 = new JButton();
			this.jButton10.setText("10");
			jButton10.setBounds(new Rectangle(110, 110, 50, 50));
			this.jButton10.setFont(new Font("Dialog", Font.BOLD, 12));
			this.jButton10.addMouseListener(new MouseListener() {

				public void mouseClicked(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mouseEntered(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mouseExited(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mousePressed(MouseEvent arg0) {
					// TODO Auto-generated method stub
					KeyPadPanel.this.keyPad.setButtonState(10, PushButton.BUTTON_DOWN);
					//System.out.println("button10 press");
				}

				public void mouseReleased(MouseEvent arg0) {
					// TODO Auto-generated method stub
					KeyPadPanel.this.keyPad.setButtonState(10, PushButton.BUTTON_UP);
					//System.out.println("button10 release");
				}});
		}
		return this.jButton10;
	}

	/**
	 * This method initializes jButton11	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton11() {
		if (this.jButton11 == null) {
			this.jButton11 = new JButton();
			this.jButton11.setText("11");
			jButton11.setBounds(new Rectangle(160, 110, 50, 50));
			this.jButton11.setFont(new Font("Dialog", Font.BOLD, 12));
			this.jButton11.addMouseListener(new MouseListener() {

				public void mouseClicked(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mouseEntered(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mouseExited(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mousePressed(MouseEvent arg0) {
					// TODO Auto-generated method stub
					KeyPadPanel.this.keyPad.setButtonState(11, PushButton.BUTTON_DOWN);
					//System.out.println("button11 press");
				}

				public void mouseReleased(MouseEvent arg0) {
					// TODO Auto-generated method stub
					KeyPadPanel.this.keyPad.setButtonState(11, PushButton.BUTTON_UP);
					//System.out.println("button11 release");
				}});
		}
		return this.jButton11;
	}

	/**
	 * This method initializes jButton12	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton12() {
		if (this.jButton12 == null) {
			this.jButton12 = new JButton();
			this.jButton12.setText("12");
			jButton12.setBounds(new Rectangle(10, 160, 50, 50));
			this.jButton12.setFont(new Font("Dialog", Font.BOLD, 12));
			this.jButton12.addMouseListener(new MouseListener() {

				public void mouseClicked(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mouseEntered(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mouseExited(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mousePressed(MouseEvent arg0) {
					// TODO Auto-generated method stub
					KeyPadPanel.this.keyPad.setButtonState(12, PushButton.BUTTON_DOWN);
					//System.out.println("button12 press");
				}

				public void mouseReleased(MouseEvent arg0) {
					// TODO Auto-generated method stub
					KeyPadPanel.this.keyPad.setButtonState(12, PushButton.BUTTON_UP);
					//System.out.println("button12 release");
				}});
		}
		return this.jButton12;
	}

	/**
	 * This method initializes jButton13	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton13() {
		if (this.jButton13 == null) {
			this.jButton13 = new JButton();
			this.jButton13.setText("13");
			jButton13.setBounds(new Rectangle(60, 160, 50, 50));
			this.jButton13.setFont(new Font("Dialog", Font.BOLD, 12));
			this.jButton13.addMouseListener(new MouseListener() {

				public void mouseClicked(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mouseEntered(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mouseExited(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mousePressed(MouseEvent arg0) {
					// TODO Auto-generated method stub
					KeyPadPanel.this.keyPad.setButtonState(13, PushButton.BUTTON_DOWN);
					//System.out.println("button13 press");
				}

				public void mouseReleased(MouseEvent arg0) {
					// TODO Auto-generated method stub
					KeyPadPanel.this.keyPad.setButtonState(13, PushButton.BUTTON_UP);
					//System.out.println("button13 release");
				}});
		}
		return this.jButton13;
	}

	/**
	 * This method initializes jButton14	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton14() {
		if (this.jButton14 == null) {
			this.jButton14 = new JButton();
			this.jButton14.setText("14");
			jButton14.setBounds(new Rectangle(110, 160, 50, 50));
			this.jButton14.setFont(new Font("Dialog", Font.BOLD, 12));
			this.jButton14.addMouseListener(new MouseListener() {

				public void mouseClicked(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mouseEntered(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mouseExited(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mousePressed(MouseEvent arg0) {
					// TODO Auto-generated method stub
					KeyPadPanel.this.keyPad.setButtonState(14, PushButton.BUTTON_DOWN);
					//System.out.println("button14 press");
				}

				public void mouseReleased(MouseEvent arg0) {
					// TODO Auto-generated method stub
					KeyPadPanel.this.keyPad.setButtonState(14, PushButton.BUTTON_UP);
					//System.out.println("button14 release");
				}});
		}
		return this.jButton14;
	}

	/**
	 * This method initializes jButton15	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton15() {
		if (this.jButton15 == null) {
			this.jButton15 = new JButton();
			this.jButton15.setText("15");
			jButton15.setBounds(new Rectangle(160, 160, 50, 50));
			this.jButton15.setFont(new Font("Dialog", Font.BOLD, 12));
			this.jButton15.addMouseListener(new MouseListener() {

				public void mouseClicked(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mouseEntered(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mouseExited(MouseEvent arg0) {
					// TODO Auto-generated method stub

				}

				public void mousePressed(MouseEvent arg0) {
					// TODO Auto-generated method stub
					KeyPadPanel.this.keyPad.setButtonState(15, PushButton.BUTTON_DOWN);
					//System.out.println("button15 press");
				}

				public void mouseReleased(MouseEvent arg0) {
					// TODO Auto-generated method stub
					KeyPadPanel.this.keyPad.setButtonState(15, PushButton.BUTTON_UP);
					//System.out.println("button15 release");
				}});
		}
		return this.jButton15;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
