package gui.highlighting;

import javax.swing.text.Document;
import javax.swing.text.Element;

    /*
2    * $Id: StructuredDocument.java,v 1.1 2007-06-11 09:48:17 e1347061 Exp $
3    ********************
4    *
5    * Copyright (c) 2001 Sun Microsystems, Inc.  All rights reserved.
6    *
7    * Redistribution and use in source and binary forms, with or without
8    * modification, are permitted provided that the following conditions
9    * are met:
10   *
11   * 1. Redistributions of source code must retain the above copyright
12   *    notice, this list of conditions and the following disclaimer.
13   *
14   * 2. Redistributions in binary form must reproduce the above copyright
15   *    notice, this list of conditions and the following disclaimer in
16   *    the documentation and/or other materials provided with the
17   *    distribution.
18   *
19   * 3. The end-user documentation included with the redistribution,
20   *    if any, must include the following acknowledgment:
21   *       "This product includes software developed by the
22   *       Sun Microsystems, Inc. for Project JXTA."
23   *    Alternately, this acknowledgment may appear in the software itself,
24   *    if and wherever such third-party acknowledgments normally appear.
25   *
26   * 4. The names "Sun", "Sun Microsystems, Inc.", "JXTA" and "Project JXTA" 
27   *    must not be used to endorse or promote products derived from this
28   *    software without prior written permission. For written
29   *    permission, please contact Project JXTA at http://www.jxta.org.
30   *
31   * 5. Products derived from this software may not be called "JXTA",
32   *    nor may "JXTA" appear in their name, without prior written
33   *    permission of Sun.
34   *
35   * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
36   * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
37   * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
38   * DISCLAIMED.  IN NO EVENT SHALL SUN MICROSYSTEMS OR
39   * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
40   * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
41   * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
42   * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
43   * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
44   * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
45   * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
46   * SUCH DAMAGE.
47   *
48   * ====================================================================
49   *
50   * This software consists of voluntary contributions made by many
51   * individuals on behalf of Project JXTA.  For more
52   * information on Project JXTA, please see
53   * <http://www.jxta.org/>.
54   *
55   * This license is based on the BSD license adopted by the Apache Foundation.
56   ********************
57   */

	/**
62   * An extension of {@link Document} which allows the content of a document to be
63   * specified by a hierarchy of elements. This allows the content of many
64   * document types to be mainpulated in an abstract way without regard to the
65   * phyiscal representation of the documents.
66   *
67   * <p/>StructuredDocuments are one of the elementary components that is
68   * manipulated by the JXTA core. StructuredDocuments are used to represent most
69   * core objects such as peer, peergroup or pipe advertisements.
70   *
71   * @see         net.jxta.document.Document
72   * @see         net.jxta.document.StructuredTextDocument
73   * @see         net.jxta.document.StructuredDocumentFactory
74   **/
  	public interface StructuredDocument extends Document, Element  {
	  
	  /**
78       * Create a new element without value
79       *
80       * @param key The key of the element to be created.
81       * @return The new element.
82       **/
  		Element createElement( Object key );
      
  		/**
86       * Create a new element with value
87       *
88       * @param   key    The name of the element to be created.
89       * @param   value  The value of the element to be created or
90       * <code>null</code> if no value is desired.
91       * @return  The new element.
92       *	
93       **/
  		Element createElement( Object key, Object value );
  	}