/**
 * 
 */
package simulator;

import java.awt.Color;
import java.awt.Graphics;

import javax.swing.JPanel;

/**
 * This class is the visualisation of the LED array peripheral of
 * CENG336 board
 * @author maho
 * @since 22.03.2007
 */
public class LEDPanel extends JPanel {

    private boolean[] state;
    
	/** 
	 * Main constructor for the LED panel. 
	 */
    public LEDPanel() {
        this.initComponents();
    }
    
    public void initComponents() {
    	this.state = new boolean[8];
    	for(int j=0; j<8; j++)
    			this.state[j] = false;
    
    }

    @Override
	public void paintComponents(Graphics g) {
    	
    	//System.out.println("SevenSegmentPanel.paintComponents()");
        
        //super.setSize(300, 300);
        //super.paintComponents(g);
    	
    	int width = 25;		//thickness of each segment
    	int height = 25;	//length of each segment
    	
    	//the offset values from the left upper corner of the frame
        int base_x;	
        int base_y;
        
        //the space between two 7segment displays
        int space_between = 40;
        
        //the colors used in seven segment displays
        Color color_off = Color.GREEN.darker();
        Color color_on = color_off.brighter();
        color_on = color_on.brighter();
        
        //fill_color = fill_color.darker();
        
        base_x = 80;
        base_y = 203;
        
        for (int i = 0; i < state.length; i++) {
        	
            
            g.setColor(color_off);
            
            g.fillOval(base_x, base_y, width, height);
            g.setColor(color_on);
            
            if(this.state[7-i])
            {
            	//System.out.println("color"+i);
            	g.fillOval(base_x, base_y, width, height);
            }
            
            base_x += space_between;
		}
    }
    
    @Override
	public void paint(Graphics g) {
    	//System.out.println("SevenSegmentPanel.paint()");
    	this.paintComponents(g);
    	
    }
    
    @Override
	public void paintAll(Graphics g) {
    	super.paintComponents(g);
    }
    /**
     * Change the state of a LED with the given index 0-7
     * @param i index of LED
     * @param arr state of LED
     */
    public void changeState(int i, boolean arr) {
    	this.state[i] = arr;
    }

}
